import 'package:dotup_flutter_widgets/GroupedListView.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import "package:collection/collection.dart";
import 'package:dotup_flutter_widgets/dotup_flutter_widgets.dart';

class GroupedListViewExample extends StatelessWidget {
  const GroupedListViewExample({
    Key? key,
  }) : super(key: key);

  @override
  build(BuildContext context) {
    final now = DateTime.now();
    final dateList = List.generate(100, (index) => now.add(Duration(hours: index)));
    final grouped = groupBy<DateTime, String>(dateList, (item) => item.toString().split(' ')[0]);

    return Scaffold(
      body: GroupedListView(
        preCalculatedGroupedItemInfo: true,
        groupedItems: grouped,
        // padding: EdgeInsets.zero,
        groupBuilder: (context, index, item) {
          return Container(
            padding: EdgeInsets.all(8),
            color: Colors.red,
            child: Text(grouped.entries.elementAt(item.groupIndex).key.toString()),
          );
        },
        itemBuilder: (context, index, item) {
          final e = grouped.entries.elementAt(item.groupIndex).value.elementAt(item.itemIndex);
          return ListTile(title: Text('${item.groupIndex} - ${item.itemIndex} - ${e.toString()}'));
        },
        separatorBuilder: (context, index, item) => Divider(
          height: 1,
        ),
      ),
    );
  }
}
